summaryrefslogtreecommitdiffstats
path: root/python/python3-pythran
diff options
context:
space:
mode:
Diffstat (limited to 'python/python3-pythran')
-rw-r--r--python/python3-pythran/README7
-rw-r--r--python/python3-pythran/python3-pythran.SlackBuild99
-rw-r--r--python/python3-pythran/python3-pythran.info10
-rw-r--r--python/python3-pythran/slack-desc19
4 files changed, 135 insertions, 0 deletions
diff --git a/python/python3-pythran/README b/python/python3-pythran/README
new file mode 100644
index 0000000000..32e80a1c06
--- /dev/null
+++ b/python/python3-pythran/README
@@ -0,0 +1,7 @@
+Pythran is an ahead of time compiler for a subset of the Python
+language, with a focus on scientific computing. It takes a Python
+module annotated with a few interface descriptions and turns it into a
+native Python module with the same interface, but (hopefully) faster.
+
+It is meant to efficiently compile scientific programs, and takes
+advantage of multi-cores and SIMD instruction units.
diff --git a/python/python3-pythran/python3-pythran.SlackBuild b/python/python3-pythran/python3-pythran.SlackBuild
new file mode 100644
index 0000000000..7c5911061b
--- /dev/null
+++ b/python/python3-pythran/python3-pythran.SlackBuild
@@ -0,0 +1,99 @@
+#!/bin/bash
+
+# Slackware build script for python3-pythran
+#
+# Copyright 2022-2024 Isaac Yu <isaacyu@protonmail.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=python3-pythran
+VERSION=${VERSION:-0.15.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+SRCNAM=pythran
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# Only LIBDIRSUFFIX is used within the SlackBuild
+if [ "$ARCH" = "i586" ]; then
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ LIBDIRSUFFIX="64"
+else
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.gz
+cd $SRCNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# Needs newer setuptools
+PYVER=$(python3 -c 'import sys; print("%d.%d" % sys.version_info[:2])')
+export PYTHONPATH=/opt/python$PYVER/site-packages/
+
+python3 -m build --no-isolation
+python3 -m installer --destdir "$PKG" dist/*.whl
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Remove bundled boost and xsimd
+rm -r $PKG/usr/lib*/python$PYVER/site-packages/pythran/{boost,xsimd}
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a AUTHORS Changelog README.rst $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/python/python3-pythran/python3-pythran.info b/python/python3-pythran/python3-pythran.info
new file mode 100644
index 0000000000..b57720bc0c
--- /dev/null
+++ b/python/python3-pythran/python3-pythran.info
@@ -0,0 +1,10 @@
+PRGNAM="python3-pythran"
+VERSION="0.15.0"
+HOMEPAGE="https://pythran.readthedocs.io/en/latest/"
+DOWNLOAD="https://files.pythonhosted.org/packages/source/p/pythran/pythran-0.15.0.tar.gz"
+MD5SUM="cc6fa05e583733182d06d2e41e03cc10"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="python3-beniget python3-numpy python3-setuptools-opt xsimd"
+MAINTAINER="Isaac Yu"
+EMAIL="isaacyu@protonmail.com"
diff --git a/python/python3-pythran/slack-desc b/python/python3-pythran/slack-desc
new file mode 100644
index 0000000000..fc98a7ab95
--- /dev/null
+++ b/python/python3-pythran/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+python3-pythran: python3-pythran (Ahead of Time compiler for numeric kernels)
+python3-pythran:
+python3-pythran: Pythran is an ahead of time compiler for a subset of the Python
+python3-pythran: language, with a focus on scientific computing. It takes a Python
+python3-pythran: module annotated with a few interface descriptions and turns it into a
+python3-pythran: native Python module with the same interface, but (hopefully) faster.
+python3-pythran:
+python3-pythran: It is meant to efficiently compile scientific programs, and takes
+python3-pythran: advantage of multi-cores and SIMD instruction units.
+python3-pythran:
+python3-pythran: